import { SandboxParameter, SandboxResult } from './interfaces';
export declare class SandboxProcess {
    readonly pid: number;
    readonly parameter: SandboxParameter;
    private readonly cancellationToken;
    private readonly stopCallback;
    private countedCpuTime;
    private actualCpuTime;
    private timeout;
    private cancelled;
    private waitPromise;
    private cleanupPromise;
    private cleanupCallback;
    private cleanupErrCallback;
    running: boolean;
    constructor(pid: number, parameter: SandboxParameter);
    private removeCgroup();
    private cleanup();
    stop(): void;
    waitForStop(): Promise<SandboxResult>;
    waitForCleanedUp(): Promise<void>;
}
